% Inspired by Sutour's code. 
clear all, close all; clc

% INPUT
filename = '../data/cameraman.pgm';


addpath .. 
addpath ../mfunctions/
addpath ./functions

% Load image
img = double(imread(filename));

img_nse = img + 5*randn(size(img))./randn(size(img));

%%


param.W = 64;
[noise, noise_info] = noise_estimation(img_nse, param);


B=[];
for l_block_start=1:noise_info.W:size(img_nse,1)-noise_info.W+1
    for k_block_start=1:noise_info.W:size(img_nse,1)-noise_info.W+1
        bloc = noise_info.hom(l_block_start:l_block_start-1+noise_info.W, k_block_start:k_block_start-1+noise_info.W);
        if sum(abs(bloc(:))) == noise_info.W*noise_info.W
            A = reshape(img_nse(l_block_start:l_block_start-1+noise_info.W, k_block_start:k_block_start-1+noise_info.W), [1,1, length(bloc(:))]);
            [a, b] = MyriadFilter(A);
            B = [B; b] ;
        end
    end
end

% Show results
figure
subplot(1,3,2)
plothomogeneous(img_nse, noise_info.W, noise_info.hom, img)
title('Homogeneous areas.')
subplot(1,3,3)
hist(B(:)), axis square
h = findobj(gca,'Type','patch');
set(h,'FaceColor',[0 .5 .5],'EdgeColor','w')
title('Estimated \gamma.')
im1 = subplot(1,3,1);
imagesc(uint8(img))
colormap(im1, gray)
axis off, axis image
title('Initial image.')

clc
disp(char(['Estimated gamma = ', num2str(mean(B))]))
