function out = K_Poisson_best_patches(input, varargin)
% [CauchySamples] = K_cauchy_best_patches(Img, ...)
% 'SampleSize'
% 'GammaCauchyParameter'
% 'PatchWidth'
% 'SearchWindowRadius'
%
% Example:
% out = K_cauchy_best_patches(input, 'GammaCauchyParameter', 5,...
%                                    'SampleSize', 30,...
%                                    'PatchWidth', 5,...
%                                    'SearchWindowRadius', 10);


% Default param :
size_of_the_sample= single(40);
patch_width=single(3);
search_window_radius=single(15);


p = inputParser;
addRequired(p, 'input', @isnumeric);
addOptional(p, 'SampleSize', size_of_the_sample, @isnumeric);
addOptional(p, 'PatchWidth', patch_width, @isnumeric);
addOptional(p, 'SearchWindowRadius', search_window_radius, @isnumeric);

parse(p, input, varargin{:});

initialtype = class(input);
input=single(input);

size_of_the_sample= single(p.Results.SampleSize);
patch_width= single(p.Results.PatchWidth);
search_window_radius= single(p.Results.SearchWindowRadius);

% out = CauchyPatchExtraction(input, gamma, size_of_the_sample,...
%     patch_width, search_window_radius);

out = poisson_similarity(input, size_of_the_sample, patch_width, search_window_radius);

out = cast(out, initialtype);

end
