function local_sample = localSample( A, r )
% local_sample = localSample( A, r )
%
% Compute for each pixel a sample composed by the local pixels around it.

initialtype = class(A);

[m,n]= size(A);

[Iy, Ix]= meshgrid(1:n,1:m);

deltax = -r:r;
deltay = -r:r;
deltax= repmat(deltax, [length(deltay(:)), 1]);
deltay= repmat(deltay', [1, length(deltay(:))]);

deltax= deltax(:);
deltay= deltay(:);

dx = repmat(reshape(deltax, [1,1, length(deltax(:))]), [m,n,1]);
dy = repmat(reshape(deltay, [1,1, length(deltay(:))]), [m,n,1]);

Iy= repmat(Iy, [1,1,length(deltay(:))]);
Ix= repmat(Ix, [1,1,length(deltax(:))]);

Ixd=Ix+dx;
Iyd=Iy+dy;

Iyd(Iyd<1) = -Iyd(Iyd<1)+1 ;
Ixd(Ixd<1) = -Ixd(Ixd<1)+1 ;

Ixd(Ixd>=m) = 2*m - Ixd(Ixd>=m)  ;
Iyd(Iyd>=n) = 2*n - Iyd(Iyd>=n)  ;

Id = reshape(sub2ind([m,n], Ixd(:), Iyd(:)), [m,n,size(Ixd,3)]);

local_sample = A(Id);

local_sample = cast(local_sample, initialtype);

end

