/*
*	MexMyriadExchange.h
*
*	Updated on:	2017-06-26
*	   Authors:	Marcel Brusius,
*				Fabien Pierre
*
*/

#pragma once

#ifndef _CRT_SECURE_NO_WARNINGS
#define _CRT_SECURE_NO_WARNINGS
#endif // !_CRT_SECURE_NO_WARNINGS

#ifndef _MEXOPENCVWRAPPER_H_
#define _MEXOPENCVWRAPPER_H_

#include <mex.h>
#include <opencv2/opencv.hpp>

// tells the compiler which libraries to use:
#ifdef _DEBUG
	#pragma comment(lib, "opencv_imgproc320d.lib")
	#pragma comment(lib, "opencv_core320d.lib")
	#pragma comment(lib, "opencv_imgcodecs320d.lib")
#else
	#pragma comment(lib, "opencv_imgproc320.lib")
	#pragma comment(lib, "opencv_core320.lib")
	#pragma comment(lib, "opencv_imgcodecs320.lib")
#endif // _DEBUG

#pragma comment(lib, "libut.lib")
#pragma comment(lib, "libmx.lib")
#pragma comment(lib, "libmat.lib")
#pragma comment(lib, "libmex.lib")

void Mex2OpenCV( const float *Input , cv::Mat Output );

void OpenCV2Mex( cv::Mat Input , float *Output );

#endif // !_MEXOPENCVWRAPPER_H_
